/* Copyright 2017-2021 Xaptum, Inc.
 * Copyright 2021 NXP
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Functions in this file comes from Xaptum, https://github.com/xaptum/ecdaa
 * */

#ifndef EX_SSS_FIDO_HASH_H_
#define EX_SSS_FIDO_HASH_H_
/* ************************************************************************** */
/* Includes                                                                   */
/* ************************************************************************** */

/* clang-format off */

/*******************************************************************
* Defines
*******************************************************************/


/**
 * @brief SHA256 hash function instance */
typedef struct
{
    uint32_t length[2]; /**< 64-bit input length */
    uint32_t h[8];      /**< Internal state */
    uint32_t w[80];	/**< Internal state */
    int hlen;		/**< Hash length in bytes */
} hash256;


/*******************************************************************************
 * Prototypes
 ******************************************************************************/
void HASH256_init(hash256 *sh);
void HASH256_process(hash256 *sh,int byt);
void HASH256_hash(hash256 *sh,char *digest);

/* clang-format on */

#endif /*  EX_SSS_FIDO_HASH_H_ */
